#!/usr/bin/perl -w

# xdb_auth_pop3 v0.1 - luis peralta / jaxp <peralta%spisa.act.uji.es>
# heavily based on xdb_auth_test by jer
# This is GPL code.

use MD5;
use Net::POP3;
use XML::Stream qw(Tree);
use Digest::SHA1 qw(sha1_hex);


$JABBERSERVER = 'najwa.carxofa.org';
$JABBERSERVERPORT = '9876';
$JABBERSECRET = 'xat';
$POP3SERVER = 'localhost'; # change to your needs

# authenticate
# recibe user y pass, devuelve 1 si correcto
sub pop3_auth {
	my ($user,$pass) = @_;
	my $pop = Net::POP3->new($POP3SERVER);
#	$pop->debug(2);
# enable this if you have MD5 module + an APOP capable pop3 server
#	if (defined($pop->apop($user,$pass))) {
	if (defined($pop->login($user,$pass))) {
		return 1;
	} else {
		return 0;
	}
}

sub connect_to_jabberd {
	my ($hostname, $port) = @_;
        $status = $stream->Connect(	hostname=>$hostname, 
					port=>$port, 
					namespace=>"jabber:component:accept", 
					myhostname=>"xdb_auth_pop3", timeout=>10);
        die("no puedo abrir conexion con $hostname:$port") if(!(defined($status)));

        # next send the hashed secret and make sure it's ok
        $stream->Send($status->{id},"<handshake>".sha1_hex($status->{id}.$JABBERSECRET)."</handshake>");
        my ($foo,$handshake) = $stream->Process();
        die("secreto incorrecto") 
		if($$handshake[0] eq "" || &XML::Stream::GetXMLData("value",$$handshake[0],"","") ne "");
}

sub main_loop {
	# now start processing packets
	while(my ($foo,$pkt) = $stream->Process()) {
		# sigues ahi?
		last if($pkt == -1);

		# packets are in the XML::Parser 'tree' format, ugly but it works
		# make sure we're just doing xdb packets
		my %attr = %{$pkt->[1]->[0]};
		next if($pkt->[0] ne "xdb");
		my $type = "error"; # default to error

		# si es un 'get', devolvemos namespace vacio indicando que hace falta comprobacion
		if($attr{type} eq "get") {
	  		$stream->Send($status->{id},"<xdb from='xdb_auth_pop3' to='$attr{from}' id='$attr{id}' type='result' ns='jabber:iq:auth'><query xmlns='jabber:iq:auth'/></xdb>");
	    		next;
		}

		# si es un 'set' + 'check' comprobamos clave corporativa
		if($attr{type} eq "set" && $attr{action} eq "check") {
			$pass = $pkt->[1]->[2]->[2];
			print "checking pass $pass for user $attr{to}\n";
			my $user = $attr{to};
			$user =~ s/\@.*//;
			if(pop3_auth($user,$pass)) {
				$type = "result";
			} else {
				$type = "error";
			}
		}

		# send back the response, be it an error or result type
		$stream->Send($status->{id},"<xdb from='xdb_auth_pop3' to='$attr{from}' id='$attr{id}' type='$type' ns='jabber:iq:auth'/>");
	}
}


$stream = new XML::Stream(style=>"tree");

connect_to_jabberd($JABBERSERVER,$JABBERSERVERPORT);
main_loop();

